import os, sys
import shutil
import time
from cStringIO import StringIO

import xml.parsers.expat

import mercurial.ui
from mercurial import localrepo
from mercurial import commands

temp_repos_dir = 'temprepos/' # TODO use tempfs
ui = mercurial.ui.ui()

cur_repo = None
cur_repo_dir = None

cur_title = None
cur_content_path = None

cur_timestamp = None
cur_contributor = None
cur_comment = None

in_element = False
cur_char_data = StringIO()

# expat handler functions
def start_element(name, attrs):
	global in_element, cur_char_data
	in_element = True
	#print '<' + name + '>'
	cur_char_data.close()
	cur_char_data = StringIO()

def char_data(data):
	global cur_char_data, in_element
	if in_element:
		cur_char_data.write(data)
		#print "data", len(data), "bytes"
		#print "----"
		#if len(data) < 50: print data
		#print "----"

def end_element(name):
	global cur_title, cur_content_path, cur_timestamp, cur_contributor, cur_comment, cur_char_data, cur_repo, cur_repo_dir
	global in_element
	in_element = False
	#print '</' + name + '>'

	if name == 'title':
		cur_title = cur_char_data.getvalue()
		cur_content_path = temp_repos_dir + cur_title + '/' + cur_title + ".wiki"

		# set up repository
		cur_repo_dir = temp_repos_dir + cur_title
		if os.path.isdir(cur_repo_dir):
			shutil.rmtree(cur_repo_dir)
		cur_repo = localrepo.localrepository(ui, path = cur_repo_dir, create = 1)

	elif name == 'timestamp':
		cur_timestamp = cur_char_data.getvalue()
	elif name == 'ip':
		cur_contributor = cur_char_data.getvalue()
	elif name == 'username':
		cur_contributor = cur_char_data.getvalue()
	elif name == 'comment':
		cur_comment = cur_char_data.getvalue()
	elif name == 'text':
		f = open(cur_content_path, 'wb')
		f.write(cur_char_data.getvalue())
		f.close()

		if cur_comment is None or len(cur_comment) == 0: cur_comment = "blank"
		timestamp = cur_timestamp.replace('T', ' ').replace('Z','') # TODO: use .translate()

		commands.addremove(ui, cur_repo)
		commands.commit(ui, cur_repo, message=cur_comment, user=cur_contributor, date=timestamp)

		cur_timestamp = None
		cur_contributor = None
		cur_comment = None

	elif name == 'page':
		commands.bundle(ui, cur_repo, temp_repos_dir + cur_title + '.hg', all=True, type='none')
		shutil.rmtree(cur_repo_dir)
		cur_title = None
		cur_content_path = None



# parse stdin
p = xml.parsers.expat.ParserCreate()
p.StartElementHandler = start_element
p.EndElementHandler = end_element
p.CharacterDataHandler = char_data
p.returns_unicode = False # we want utf8
p.buffer_text = True # be faster and don't call char_data for every line
p.ParseFile(sys.stdin)


#!!!!!!!!!!!!!!!!!!
# NOT FINISHED
#!!!!!!!!!!!!!!!!!!
